"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports["default"]=exports.GROUPEND=exports.GROUPBEGIN=exports.CLEAR=exports.REDO=exports.UNDO=exports.getDevData=exports.getLibData=void 0;var _toolkit=require("@reduxjs/toolkit"),_getDeepDiffItem=_interopRequireDefault(require("./getDeepDiffItem")),_getDeepDiff=_interopRequireDefault(require("./getDeepDiff")),_getNewPastWithMaxHistoryCheck=_interopRequireDefault(require("./getNewPastWithMaxHistoryCheck"));function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}function ownKeys(a,b){var c=Object.keys(a);if(Object.getOwnPropertySymbols){var d=Object.getOwnPropertySymbols(a);b&&(d=d.filter(function(b){return Object.getOwnPropertyDescriptor(a,b).enumerable})),c.push.apply(c,d)}return c}function _objectSpread(a){for(var b,c=1;c<arguments.length;c++)b=null==arguments[c]?{}:arguments[c],c%2?ownKeys(Object(b),!0).forEach(function(c){_defineProperty(a,c,b[c])}):Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(b)):ownKeys(Object(b)).forEach(function(c){Object.defineProperty(a,c,Object.getOwnPropertyDescriptor(b,c))});return a}function _defineProperty(a,b,c){return b in a?Object.defineProperty(a,b,{value:c,enumerable:!0,configurable:!0,writable:!0}):a[b]=c,a}function _toConsumableArray(a){return _arrayWithoutHoles(a)||_iterableToArray(a)||_unsupportedIterableToArray(a)||_nonIterableSpread()}function _nonIterableSpread(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(a,b){if(a){if("string"==typeof a)return _arrayLikeToArray(a,b);var c=Object.prototype.toString.call(a).slice(8,-1);return"Object"===c&&a.constructor&&(c=a.constructor.name),"Map"===c||"Set"===c?Array.from(a):"Arguments"===c||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(c)?_arrayLikeToArray(a,b):void 0}}function _iterableToArray(a){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(a))return Array.from(a)}function _arrayWithoutHoles(a){if(Array.isArray(a))return _arrayLikeToArray(a)}function _arrayLikeToArray(a,b){(null==b||b>a.length)&&(b=a.length);for(var c=0,d=Array(b);c<b;c++)d[c]=a[c];return d}var _=require("lodash"),diff=require("deep-diff").diff,WRAPKEY="__wrapper",DEBUGPREPEND="[easy-redux-undo]=>",LIBRARYPREFIX="@@easy-redux-undo/",UNDOACTION="".concat(LIBRARYPREFIX,"UNDO"),REDOACTION="".concat(LIBRARYPREFIX,"REDO"),CLEARACTION="".concat(LIBRARYPREFIX,"CLEAR"),GROUPBEGINACTION="".concat(LIBRARYPREFIX,"GROUPBEGIN"),GROUPENDACTION="".concat(LIBRARYPREFIX,"GROUPEND"),UNDO=(0,_toolkit.createAction)(UNDOACTION);exports.UNDO=UNDO;var REDO=(0,_toolkit.createAction)(REDOACTION);exports.REDO=REDO;var CLEAR=(0,_toolkit.createAction)(CLEARACTION);exports.CLEAR=CLEAR;var GROUPBEGIN=(0,_toolkit.createAction)(GROUPBEGINACTION);exports.GROUPBEGIN=GROUPBEGIN;var GROUPEND=(0,_toolkit.createAction)(GROUPENDACTION);exports.GROUPEND=GROUPEND;var defaultOptions={maxHistory:100,undoType:UNDOACTION,redoType:REDOACTION,clearType:CLEARACTION,groupBeginType:GROUPBEGINACTION,groupEndType:GROUPENDACTION,include:[],exclude:[],cloneDeepFunc:_.cloneDeep},getLibData=function(a){return a.lib};exports.getLibData=getLibData;var getDevData=function(a){return a.dev};exports.getDevData=getDevData;var undoable=function(a){var b=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};if(b=Object.assign(defaultOptions,b),0<b.include.length&&0<b.exclude.length)return void console.error("".concat(DEBUGPREPEND," cannot have both a 'include' and 'exclude' property, choose one or the other!"));var c=function(a,b,c){try{diff[a](b,!0,c)}catch(d){"development"===process.env.NODE_ENV&&console.error("diff.".concat(a," failed;"),"state:",b,"libData:",c)}},d=function(a,d,e){var f,g=3<arguments.length&&void 0!==arguments[3]?arguments[3]:void 0,h=4<arguments.length&&void 0!==arguments[4]?arguments[4]:void 0,l=5<arguments.length&&void 0!==arguments[5]?arguments[5]:void 0,m={},n=g||a,o=l||e,p=!1,q=n.length-1,r=n[q];if(getLibData(r)===b.groupEndType){m=getDevData(r);var s=q-1;for(s;0<=s&&getLibData(n[s])!==b.groupBeginType;s--);if(0==s&&getLibData(n[s])!==b.groupBeginType)throw new Error("".concat(DEBUGPREPEND," did not find a closed group of actions to undo, did you forget to send a '").concat(b.groupBeginType,"' action?"));r=[];for(var t=q-1;t>=s+1;t--)r.push(n[t]);q=s,p=!0}if(n=n.slice(0,q),f=h||_.cloneDeep(d),Array.isArray(f)&&(f["".concat(WRAPKEY)]=f),p)for(var i=0;i<r.length;i++)for(var j=0;j<getLibData(r[i]).length;j++)c("revertChange",f,getLibData(r[i])[j]);else for(var k=0;k<getLibData(r).length;k++)c("revertChange",f,getLibData(r)[k]);return f=Array.isArray(f)?f["".concat(WRAPKEY)]:f,o=p?[{lib:b.groupEndType,dev:m}].concat(_toConsumableArray(r),[{lib:b.groupBeginType}],_toConsumableArray(o)):[r].concat(_toConsumableArray(o)),{past:n,present:f,future:o}},e=function(a,d,e){var f,g=3<arguments.length&&void 0!==arguments[3]?arguments[3]:void 0,h=4<arguments.length&&void 0!==arguments[4]?arguments[4]:void 0,l=5<arguments.length&&void 0!==arguments[5]?arguments[5]:void 0,m={},n=g||a,o=l||e,p=!1,q=1,r=o[q-1];if(getLibData(r)===b.groupEndType){m=getDevData(r);var s=q;for(s;s<=o.length&&getLibData(o[s])!==b.groupBeginType;s++);if(s===o.length-1&&getLibData(o[s])!==b.groupBeginType)throw new Error("".concat(DEBUGPREPEND," did not find a closed group of actions to redo, something must have went wrong!"));r=[];for(var t=s-1;t>=q;t--)r.push(o[t]);q=s+1,p=!0}if(o=o.slice(q),f=h||_.cloneDeep(d),Array.isArray(f)&&(f["".concat(WRAPKEY)]=f),p)for(var i=0;i<r.length;i++)for(var j=0;j<getLibData(r[i]).length;j++)c("applyChange",f,getLibData(r[i])[j]);else for(var k=0;k<getLibData(r).length;k++)c("applyChange",f,getLibData(r)[k]);return f=Array.isArray(f)?f["".concat(WRAPKEY)]:f,n=p?[].concat(_toConsumableArray(n),[{lib:b.groupBeginType}],_toConsumableArray(r),[{lib:b.groupEndType,dev:m}]):[].concat(_toConsumableArray(n),[r]),{past:n,present:f,future:o}};return function(){var c=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},f=1<arguments.length?arguments[1]:void 0,g=c.past,h=c.present,j=c.future,k=c.groupBeginState;if("undefined"==typeof h)return{past:[],present:a(void 0,{}),future:[]};var l="number"==typeof f.payload&&0<f.payload?f.payload:1;switch(f.type){case b.groupBeginType:{var x=b.cloneDeepFunc(h);return{past:[].concat(_toConsumableArray(g),[{lib:b.groupBeginType,dev:b.groupBeginType}]),present:h,future:j,groupBeginState:x}}case b.groupEndType:{var m=g.slice(0,-1),n=(0,_getDeepDiffItem["default"])(k,h,b,f.payload);return{past:(0,_getNewPastWithMaxHistoryCheck["default"])(m,n,b.maxHistory),present:h,future:[]}}case b.clearType:return{past:[],present:h,future:[]};case b.undoType:{if(0===g.length)return{past:g,present:h,future:j};for(var o={},p=1;p<=l&&(o=d(g,h,j,o.past,o.present,o.future),0!==o.past.length);p++);return o}case b.redoType:{if(0===j.length)return{past:g,present:h,future:j};for(var q={},r=1;r<=l&&(q=e(g,h,j,q.past,q.present,q.future),0!==q.past.length);r++);return q}default:{for(var s=a(h,f),t=!1,u=g.length-1;0<=u&&getLibData(g[u])!==b.groupEndType;u--)if(getLibData(g[u])===b.groupBeginType){t=!0;break}if(t)return{past:g,present:s,future:j,groupBeginState:k};if(!t&&(0<b.include.length&&!b.include.includes(f.type.slice(f.type.indexOf("/")))||0<b.exclude.length&&b.exclude.includes(f.type)))return{past:g,present:s,future:j};var y=(0,_getDeepDiff["default"])(h,s,b);if("undefined"==typeof y)return c;var v=_objectSpread({ts:Date.now()},f.historyPayload),w={lib:y,dev:v};return{past:(0,_getNewPastWithMaxHistoryCheck["default"])(g,w,b.maxHistory),present:s,future:[]}}}}},_default=undoable;exports["default"]=_default;